DEFINT A-Z
REM $DYNAMIC

    TYPE RegType
        ax    AS INTEGER
        bx    AS INTEGER
        cx    AS INTEGER
        dx    AS INTEGER
        bp    AS INTEGER
        si    AS INTEGER
        di    AS INTEGER
        flags AS INTEGER
    END TYPE

    TYPE RegTypeX
        ax    AS INTEGER
        bx    AS INTEGER
        cx    AS INTEGER
        dx    AS INTEGER
        bp    AS INTEGER
        si    AS INTEGER
        di    AS INTEGER
        flags AS INTEGER
        ds    AS INTEGER
        es    AS INTEGER
    END TYPE

    TYPE UserData
        Handle    AS STRING * 30   '{Users Alias}
        FName     AS STRING * 30   '{Users FIRST name}
        LName     AS STRING * 30   '{Users LAST Name}
        TimeLeft  AS INTEGER       '{Time left TODAY}
        Fairy     AS INTEGER       '{User has fairy with him (Boolean)}
        ID        AS INTEGER       '{Users LORD ID number}
    END TYPE
   
    TYPE Charactor
        Handle     AS STRING * 20 '//str[20]  {player handle in the game}
        RealName   AS STRING * 50 '//str[50]  {real name/or handle from BBS} ;
        HitPoints  AS INTEGER     '//         {player hit points}
        Bad        AS INTEGER     '//         {don't know - might not be used at all}
        Rate       AS INTEGER     '//int;     {again, couldn't find this one in the source}
        HitMax     AS INTEGER     '//int;     {hit_point max}
        WeaponNum  AS INTEGER     '//int;     {weapon number}
        Weapon     AS STRING * 20 '//str[20]; {name of weapon}
        SeenMaster AS INTEGER     '//int;     {equals 5 if seen master, else 0}
        FightsLeft AS INTEGER     '//int;     {forest fights left}
        HumanLeft  AS INTEGER     '//int;     {human fights left}
        Gold       AS LONG        '//lint;    {gold in hand}
        Bank       AS LONG        '//lint;    {gold in bank}
        Defense    AS INTEGER     '//int;     {total defense points/MAX=9999}
        Strength   AS INTEGER     '//int;     {total strength/MAX=9999}
        Charm      AS INTEGER     '//int;     {good looking meter/MAX=32767}
        SeenDragon AS INTEGER     '//int;     {seen dragon?  5 if yes else 0}
        SeenViolet AS INTEGER     '//int;     {seen violet?  5 if yes else 0}
        Level      AS INTEGER     '//int;     {level of player}
        Time       AS INTEGER     '//word;    {day # that player last played on}
        Arm        AS STRING * 20 '//str[20]; {armour name}
        ArmNum     AS INTEGER     '//int;     {armour number}
        Dead       AS INTEGER     '//sint;    {player dead?  5 if yes else 0}
        Inn        AS INTEGER     '//sint;    {player sleeping at inn?  5 if yes else 0}
        Gem        AS INTEGER     '//int;     {# of gems on hand}
        Experience AS LONG        '//lint;    {experience}
        Sex        AS INTEGER     '//sint;    {gender, 5 if female else 0}
        SeenBard   AS INTEGER     '//sint;    {seen bard?  5 if yes else 0}
        LastAlive  AS INTEGER     '//int;     {day # player was last reincarnated on}
        Lays       AS INTEGER     '//int;     {players lays stat}
        Why        AS INTEGER     '//int;     {not used yet}
        OnNow      AS INTEGER     '//boo;     {is player on?}
        Mtime      AS INTEGER     '//int;     {day on_now stat was last used}
        TimeOn     AS STRING * 5  '//str[5];  {time player logged on in Hour:Minutes format}
        Class      AS INTEGER     '//sint;    {class, 1=, 2=, 3=}
        Horse      AS INTEGER     '//int;     {*NEW*  If 1, player has a horse}
        Love       AS STRING * 25 '//str[25]; {not used - may be used for inter-player marrages later}
        Married    AS INTEGER     '//int;     {who player is married to, should be -1 if not married}
        Kids       AS INTEGER     '//int;     {# of kids}
        King       AS INTEGER     '//int;     {# of times player has won game}
        SkillW     AS INTEGER     '//sint;    {number of Death Knight skill points}
        SkillM     AS INTEGER     '//sint;    {number of Mystical Skills points}
        SkillT     AS INTEGER     '//sint;    {number of Thieving Skills points}
        LevelW     AS INTEGER     '//sint;    {number of Death Knight skill uses left today}
        LevelM     AS INTEGER     '//sint;    {number of Mystical skill uses left today}
        LevelT     AS INTEGER     '//sint;    {number of Thieving skill uses left today}
        InnRandom  AS INTEGER     '//boo;     {not used yet}
        MarriedTo  AS INTEGER     '//int;     {same as Married, I think - don't know why it's here}
        V1         AS LONG        '//lint;
        V2         AS INTEGER     '//int;     {# of player kills}
        V3         AS INTEGER     '//int;     {if 5, 'wierd' event in forest will happen}
        V4         AS INTEGER     '//boo;     {has player done 'special' for that day?}
        V5         AS INTEGER     '//sint;    {has player flirted with another player that day?  if so, 5}
        NewStat1   AS INTEGER     '//sint;
        NewStat2   AS INTEGER     '//sint;    {these 3 are unused right now}
        NewStat3   AS INTEGER     '//sint;    {Warning: Joseph's NPCLORD screws with all three}
    END TYPE
  
    TYPE ControlVars               '{(Cont.)... Variables used in system}
        DoorName   AS STRING * 30  '{Name of Program}
        Version    AS STRING * 10  '{Program Version Number}
        BBSName    AS STRING * 30  '{Name of BBS}
        SFirstName AS STRING * 15  '{SysOps First Name}
        SLastName  AS STRING * 15  '{SysOps Last Name}
        LoginName  AS STRING * 50  '{Players StatusBar Name}
        LocalEXE   AS INTEGER      '{LOCAL Execution (BooLean)}
        AnsiOn     AS INTEGER      '{Ansi selected by user (Boolean)}
        RIPOn      AS INTEGER      '{RIP terminal emulation used (Boolean)}
        Clean      AS INTEGER      '{Clean Mode (Boolean)}
        AnsiDEF    AS INTEGER      '{Default Ansi Color}
        CommPort   AS INTEGER      '{CommPort to open}
        CnctBaud   AS LONG         '{BaudRate at which user connected}
        DTERate    AS LONG         '{DTE locked baud}
        Fossil     AS INTEGER      '{FOSSIL used (Boolean)}
        IRQ        AS INTEGER      '{Non-Standard IRQ}
        HandShake  AS INTEGER      '{0=None/1=Xon-Xoff/2=RTS-CTS/3=Both
        FiveFlag   AS INTEGER      '{Flag set when User has less than 5 minutes left}
        Node       AS INTEGER      '{Node number for this game}
        LORDDir    AS STRING * 31  '{LORD Main Directory}
        SysDir     AS STRING * 31  '{IGM Main Directory}
        RegCode    AS STRING * 30  '{IGM Registration Code}
        LORDReg    AS INTEGER      '{Is LORD Registered? (Boolean)}
        LORDInfo   AS STRING * 43  '{LORD Node DATAFILE (INFO??.DAT)}
        LORDPlayer AS STRING * 43  '{LORD Player DATAFILE}
        DeBug      AS INTEGER      '{IGM debug mode (Boolean)}
        Nasty      AS INTEGER      '{Force CRT register to 980 (Boolean)} (01-01-96)
     END TYPE

    DECLARE SUB INTERRUPT (intnum AS INTEGER, inreg AS RegType, outreg AS RegType)
    DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)
    DECLARE SUB ABSOLUTE (address AS INTEGER)
    DECLARE SUB INT86OLD (intnum AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
    DECLARE SUB INT86XOLD (intnum AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
    DECLARE SUB OpenComm CDECL ALIAS "_open_comm" (BYVAL Port, IRQ, BYVAL Wlen, BYVAL Parity, BYVAL Baud&, BYVAL HS, BYVAL Fossil)
    DECLARE SUB CloseComm CDECL ALIAS "_close_comm" ()
    DECLARE FUNCTION WriteChar CDECL ALIAS "_writechar" (BYVAL c)
    DECLARE FUNCTION ReadChar CDECL ALIAS "_readchar" ()
    DECLARE SUB Transmit CDECL ALIAS "_transmit_string" (addr$)
    DECLARE FUNCTION DataWaiting CDECL ALIAS "_data_waiting" ()
    DECLARE SUB ClearInputBuffer CDECL ALIAS "_clear_input_buffer" ()
    DECLARE SUB CarrierDetect CDECL ALIAS "_carrier_detect_flag" (BYVAL OnOff)
    DECLARE FUNCTION CarrierLost CDECL ALIAS "_carrier_state" ()
    DECLARE FUNCTION DriverCopyright CDECL ALIAS "_drivercopyright" ()
    DECLARE SUB DTRcontrol CDECL ALIAS "_dtr" (BYVAL OnOff)
    DECLARE SUB RTScontrol CDECL ALIAS "_rts" (BYVAL Onff)
    DECLARE FUNCTION ModemStatus CDECL ALIAS "_inputstatus" ()

    DECLARE FUNCTION GetVSeg (Mono)
   
    DECLARE SUB PDCLS ()
    DECLARE SUB PDCOLOR (FGColor, BGColor, Blink)
    DECLARE SUB PDINKEY (Key$)
    DECLARE SUB PDINPUT (Question$, Dat$)
    DECLARE SUB PDLOCATE (H, V)
    DECLARE SUB PDMULTI (Dat$, Cr)
    DECLARE SUB PDPRINT (F, B, Bl, Dat$, Cr)
   
    DECLARE SUB ChangeDrive (Drive$)
    DECLARE SUB CloseDoor (Mode)
    DECLARE SUB ClearScreen ()
    DECLARE SUB CurrentDrive (Drive$)
    DECLARE SUB ColorCvt (FGColor, BGColor, Blink, Seq$)
    
    DECLARE SUB DisplayFile (FileName$, ClearScrn, More, DispStatus)
    DECLARE SUB DoCharm (Mode, Value)
    DECLARE SUB DoDefense (Mode, Value)
    DECLARE SUB DoGem (Mode, Value)
    DECLARE SUB DoGold (Mode, Value&)
    DECLARE SUB DoHP (Mode, Value)
    DECLARE SUB DoStr (Mode, Value)
    DECLARE SUB DoXP (Mode, Value&)

    DECLARE SUB ErHandle ()
    
    DECLARE SUB FileExist (FileName$, Result)
    DECLARE SUB FlushComm (Dat$)
    
    DECLARE SUB GetPath (Path$)
   
    DECLARE SUB HealHP (Value)
   
    DECLARE SUB Init ()
    DECLARE SUB InitComm (Port, IRQ, Baud&, DTE&, Fossil, HShake)
    DECLARE SUB InitSystem ()
    
    DECLARE SUB LordColor (Dat$)
    
    DECLARE SUB MSM (Minutes)
    
    DECLARE SUB OpenFile (FileName$, FileNum, Mode, Length)
   
    DECLARE SUB PathReturn (Mode)
    DECLARE SUB Player (Mode, Name$, RecNum)
    DECLARE SUB ProBase (DIOCode, Lck, Idx, RecLen, IdxLen, Index$, Record$, DBName$)
    DECLARE SUB PrintANSI (Char)
    DECLARE SUB PrintString (B$)
    
    DECLARE SUB QuickStop (Mode, Text$)
   
    DECLARE SUB RandGold (Size, Value&)
    DECLARE SUB RandDamage (Size, Value)
    DECLARE SUB RandXP (Size, Value&)
    DECLARE SUB ReadConfig (ConfigFile$)
    DECLARE SUB ReadINFO (Mode)
    DECLARE SUB ReadNODE (Node$)
    DECLARE SUB RealDefense (Value)
    DECLARE SUB RealStrength (Value)
    
    DECLARE SUB ScrollUpScreen ()
    DECLARE SUB SendStatus (X, Y)
    DECLARE SUB SetCursor ()
    DECLARE SUB SetWindow (WorkPage, Lx, Ly, Hx, Hy)
    DECLARE SUB StatusBar ()
    DECLARE SUB SendMore ()
    DECLARE SUB SendPress ()
    
    DECLARE SUB TakeHP (Value)
    DECLARE SUB TimedOut (Event)
    DECLARE SUB TimeMonitor (TimeLeft)

    COMMON SHARED /U1/ User AS UserData
    COMMON SHARED /U2/ Char AS Charactor
    COMMON SHARED /C1/ Cont AS ControlVars
    COMMON SHARED /S1/ VPos, HPos, MinH, MinV, MaxH, MaxV, SaveX, SaveY
    COMMON SHARED /S2/ Colors(), Attribute, CursorOn, VideoSegment, CRT
    COMMON SHARED /S3/ CursorAddress, BytesPerLine, Monochrome, VideoOffset
    COMMON SHARED /M1/ CRLF$, Key$, TorF$(), True, FGColor, BGColor, Blink
    COMMON SHARED /M2/ ANSIMusic, Level, MusicLevel, LockTries, LockReTry
    COMMON SHARED /M3/ Warrior$, DirReturnOK

